#include "StdAfx.h"
#include "ProfileWnd.h"
#include "NeMessengerDlg.h"
#include "main_frame.hpp"
#include "SendNoteMananger.h"
#include "../../DuiLib/ucslib.h"
#include "FavoriteCreateDlg.h"
#include "CreateNewGroupWnd.h"

const TCHAR* const kBtnRelateWorker = _T("btn_related_worker");
#define ID_MENU_COPY		100001

DUI_BEGIN_MESSAGE_MAP(CProfileWnd, WindowImplBase, FALSE)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_MENU, _OnNotifyMenu)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_BUTTONDOWN, _OnNotifyBtnDown)
	//DUI_ON_MSGTYPE(DUI_MSGTYPE_SET_CURSOR, OnNotifySetCurSor)

	DUI_ON_CLICK_CTRNAME(kBtnRelateWorker, _OnNotifyBtnRelateWorkerClick)
    DUI_ON_CLICK_CTRNAME(kCloseButtonControlName, _OnNotifyBtnCloseClick)
    DUI_ON_CLICK_CTRNAME(kFavorite, _OnNotifyBtnFavoriteClick)
    DUI_ON_CLICK_CTRNAME(kBtnChat, _OnNotifyBtnChatClick)
    DUI_ON_CLICK_CTRNAME(kBtnMail, _OnNotifyBtnMailClick)
    DUI_ON_CLICK_CTRNAME(kBtnSMS, _OnNotifyBtnSMSClick)
    DUI_ON_CLICK_CTRNAME(kBtnPhone, _OnNotifyBtnPhoneClick)
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CProfileWnd)
    ON_CUSTOM_MSG(WM_USERIMAGE_UPDATED, _OnMsgUserImageUpdated)
    ON_CUSTOM_MSG(WM_KEYDOWN, _OnMsgKeyDown)
    ON_CUSTOM_MSG(WM_SYSKEYDOWN, _OnMsgSysKeyDown)
    ON_CUSTOM_MSG(WM_ACTIVATE, _OnMsgActivate)
    
    BEGIN_CUSTOM_COMMAND_GROUP()
        ON_CUSTOM_COMMAND_RANGE_MSG(WM_USER_ID_LIST, (WM_USER_ID_LIST + 1000), _OnCommandRangeUserId)
        ON_CUSTOM_COMMAND_MSG(ID_MENU_CREATE_FAVORITE_GROUP, _OnCommandMnCreateFavoriteGroup)
    END_CUSTOM_COMMAND_GROUP()
     
DUI_END_CUSTOM_MSG_MAP()

CProfileWnd::CProfileWnd()
{
	m_pImageDownloadThread = NULL;
	m_hInternetSession = NULL;
	m_hHttpConnection = NULL;
	m_hParentWnd = NULL;
	m_hHttpFile = NULL;
	m_bAbort = FALSE;
	m_bSafeToClose = FALSE;
	m_bEnableClose = TRUE;
	m_rcClient.SetRectEmpty();
    m_bClosing = FALSE;
	
	for (int i=0; i<2; ++i)
	{
		m_szBtnReleteWorker[i].cx = 0;
		m_szBtnReleteWorker[i].cy = 0;
		m_strBtnReleteWorker[i] = _T("");
	}
}

CProfileWnd::~CProfileWnd()
{
	
}

CControlUI* CProfileWnd::CreateControl(LPCTSTR pstrClass)
{
	CUCDialogBuilder builder;
	CControlUI *pControl = builder.CreateControl(pstrClass);
	if (pControl)
	{
		return pControl;
	}

	pControl = __super::CreateControl(pstrClass);

	return pControl;

}


void CProfileWnd::SetParentHwnd(HWND hParentWnd)
{
	m_hParentWnd = hParentWnd;
}

HWND CProfileWnd::GetParentHwnd()
{
	return m_hParentWnd;
}

void CProfileWnd::SetClientRect(CRect rc)
{
	m_rcClient = rc;
	SetWindowPos(GetHWND(), HWND_TOP, m_rcClient.left, m_rcClient.top, m_rcClient.Width(), m_rcClient.Height(), SWP_FRAMECHANGED | SWP_HIDEWINDOW);
}

void CProfileWnd::InitWindow()
{
	g_pMessengerActor->GetWASActor()->RegisterObserver(this);
	CUserImageActor::Instance()->RegisterObserver(this);

	SetWindowPos(GetHWND(), HWND_TOP, m_rcClient.left, m_rcClient.top, m_rcClient.Width(), m_rcClient.Height(), SWP_FRAMECHANGED | SWP_HIDEWINDOW);

	UINT resid[] = {IDS_STRING722,IDS_STRING723,IDS_STRING724,IDS_STRING725,IDS_STRING726,IDS_STRING727,IDS_STRING728,IDS_STRING730,IDS_STRING731, 
		IDS_STRING273, IDS_STRING275, IDS_STRING280, IDS_STRING635};
	TCHAR *arrich[] = {_T("btn_txt_chat"),_T("btn_txt_mail"),_T("btn_txt_sms"),_T("btn_txt_phone"),_T("txt_mail"),_T("txt_ext"),_T("txt_mobile"), _T("txt_org"),_T("txt_city"),
	_T("txt_fax"), _T("txt_roaming_phone"), _T("txt_related_worker"), _T("txt_work_status")};
	for (int i = 0; i < sizeof(arrich)/sizeof(arrich[0]); i++)
	{
		CLabelUI* pLabel = static_cast<CLabelUI*>(m_PaintManager.FindControl(arrich[i]));
		if (pLabel != NULL)
		{
			pLabel->SetText(LoadStringFromResource(resid[i]));
			pLabel->SetToolTip(LoadStringFromResource(resid[i]));
		}
	}

	TCHAR *earray[] = {_T("edit_mail"),_T("edit_ext"),_T("edit_mobile"),_T("edit_company"),_T("edit_org"),_T("edit_city")};
	
	for (int i = 0; i < sizeof(earray)/sizeof(earray[0]); i++)
	{
		CUCLabel* pLabel = static_cast<CUCLabel*>(m_PaintManager.FindControl(earray[i]));
		if (pLabel != NULL)
		{
			pLabel->SetContextMenuUsed(true);
		}
	}
	CButtonUI* pBtnClose = static_cast<CButtonUI*>(m_PaintManager.FindControl(kCloseButtonControlName));
	if(pBtnClose != NULL)
	{
		pBtnClose->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_7));
	}
	if (g_stNtalkInfo.strCorp == _T("hanatour"))
	{
		CButtonUI* pBtnMail = static_cast<CButtonUI*>(m_PaintManager.FindControl(kBtnMail));
		if(pBtnMail != NULL)
		{
			pBtnMail->SetNormalImage(_T("img_main_organization_icon_sendmessage_nor.png"));
			pBtnMail->SetHotImage(_T("img_main_organization_icon_sendmessage_pre.png"));
			pBtnMail->SetPushedImage(_T("img_main_organization_icon_sendmessage_pre.png"));
			pBtnMail->SetDisabledImage(_T("img_main_organization_icon_sendmessage_dis.png"));
		}
	}
	m_bClosing = FALSE;
}

void CProfileWnd::SetRequestID(LPCTSTR strID)
{
	m_strID = strID;
	m_trid = 0;
	g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(m_strID, GetLanguageStringUnicode(), reitSingleTrans, &m_trid);
	list<std::wstring> listUserId;
	wstring strBuf(strID);
	listUserId.push_back(strBuf);
	CUserImageActor::Instance()->RequestUserImages(listUserId);

	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	m_strMyID = myUserData.strUserID;
}

LPCTSTR CProfileWnd::GetWindowClassName() const
{
	return _T("ProfileWindow");
}

void CProfileWnd::OnFinalMessage(HWND hWnd)
{
	m_hParentWnd = NULL;
	CUserImageActor::Instance()->UnRegisterObserver(this);
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);
	delete g_pProfileWnd;
	g_pProfileWnd = NULL;
}

void CProfileWnd::SetLayerBkImage(LPCTSTR lpszName)
{
	CControlUI* pbtnlayer= static_cast<CControlUI*>(m_PaintManager.FindControl(_T("btnlayer")));
	if (pbtnlayer)
	{
		pbtnlayer->SetBkImage(lpszName);
		pbtnlayer->Invalidate(TRUE);
	}		
}

BOOL CProfileWnd::IsSelectFavoriteBtn(CButtonUI *pBtn)
{
	BOOL bSelect = FALSE;
	CString strImage = pBtn->GetBkImage();
	if (strImage == FAVORITE_SELECT)
	{
		bSelect = TRUE;
	}

	return bSelect;
}

BOOL CProfileWnd::IsAllIdsInBuddyGroup(CStringList& selectedIdList, int nGroupID)
{
	BOOL bAllUsersAreInTheBuddyGroup = TRUE;	// selectedIdList  ڰ nGroupID ȿ  ִٸ TRUE

	int buddyCount = g_pMessengerActor->GetBuddyCount(nGroupID);

	CStringList buddyIdInGroup;
	for (int index = 0; index < buddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(nGroupID, index);
		CString strBuddyID = pUser->GetUserID();
		buddyIdInGroup.AddTail(strBuddyID);
	}

	POSITION pos = selectedIdList.GetHeadPosition();

	while (pos)
	{
		CString strID = selectedIdList.GetNext(pos);

		if (buddyIdInGroup.Find(strID) == NULL)
		{
			bAllUsersAreInTheBuddyGroup = FALSE;
			break;
		}
	}

	return bAllUsersAreInTheBuddyGroup;
}

void CProfileWnd::OnBtnFavoriteDelete(CString strUserID)
{
	GET_MESSENGER_DLG()->GetMainFrame()->OnBtnFavoriteDelete(strUserID);
}

void CProfileWnd::OnBtnFavoriteAdd(TNotifyUI& msg)
{
	CMenu menuFavoriteList;
	if (!menuFavoriteList.CreatePopupMenu())
	{
		return;
	}
	if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(m_userData.strUserId.c_str()))
	{
		return;
	}
	m_GroupList.clear();
	CStringList selectedIdList;
	selectedIdList.AddTail(m_userData.strUserId.c_str());
	
	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	int nAddableBuddyGroupCount = 0;
	int nMenuIndex = 0;
	for (size_t i = 0; i < nGroupCount; i++)
	{
		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);
		CString strGroupName = pGroup->GetName();
		int nGroupID = pGroup->GetID();
		if (!IsAllIdsInBuddyGroup(selectedIdList, nGroupID))
		{
			m_GroupList.insert(std::make_pair(WM_USER_ID_LIST + nMenuIndex, nGroupID));
			menuFavoriteList.AppendMenu(MF_STRING, WM_USER_ID_LIST + nMenuIndex++, strGroupName);
			nAddableBuddyGroupCount++;
		}

	}
	menuFavoriteList.AppendMenu(MF_STRING, ID_MENU_CREATE_FAVORITE_GROUP, LoadStringFromResource(IDS_STRING261));

	CPoint point = msg.ptMouse;
	ClientToScreen(m_hWnd, &point);
	menuFavoriteList.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, CWnd::FromHandle(m_hWnd));
}

void CProfileWnd::_OnNotifyMenu(TNotifyUI& msg)
{
    POINT pt = {0};
    GetCursorPos(&pt);

    CUCLabel *pobj = (CUCLabel*)msg.pSender;

    //CString s = LoadStringFromResource(IDS_COPY);
    HMENU hMenu = CreatePopupMenu();
    AppendMenu(hMenu,MF_STRING,ID_MENU_COPY,LoadStringFromResource(IDS_COPY));
    if (ID_MENU_COPY == ::TrackPopupMenu(hMenu,TPM_LEFTALIGN | TPM_RETURNCMD |TPM_RIGHTBUTTON, pt.x, pt.y,0,m_hWnd,NULL))
    {
        pobj->Copy();
    }
    DestroyMenu(hMenu);
    hMenu = NULL;
}

void CProfileWnd::_OnNotifyBtnDown(TNotifyUI& msg)
{
    if(_tcsicmp(msg.pSender->GetName(), kBtnChat) == 0)
    {
        SetLayerBkImage(_T("btn_img_main_organization_menu_01.png"));
    }
    else if(_tcsicmp(msg.pSender->GetName(), kBtnMail) == 0)
    {
        SetLayerBkImage(_T("btn_img_main_organization_menu_02.png"));
    }
    else if(_tcsicmp(msg.pSender->GetName(), kBtnPhone) == 0)
    {
        SetLayerBkImage(_T("btn_img_main_organization_menu_04.png"));
    }
    else if(_tcsicmp(msg.pSender->GetName(), kBtnSMS) == 0)
    {
        SetLayerBkImage(_T("btn_img_main_organization_menu_03.png"));
    }
}

void CProfileWnd::_OnNotifyBtnCloseClick(TNotifyUI& msg)
{
    SetLayerBkImage(_T("btn_img_main_organization_menu_00.png"));
    m_bClosing = TRUE;
    g_pProfileWnd->CloseProfileWnd();
}

void CProfileWnd::OnNotifySetCurSor(TNotifyUI& msg)
{

}

void CProfileWnd::_OnNotifyBtnRelateWorkerClick(TNotifyUI& msg)
{
	CRect rcBtn = msg.pSender->GetPos();
	CRect rcBtn1 = rcBtn;
	rcBtn1.right = rcBtn1.left + m_szBtnReleteWorker[0].cx;
	CRect rcBtn2 = rcBtn;
	rcBtn2.left = rcBtn2.right - m_szBtnReleteWorker[1].cx;

	CRect rcWnd;
	GetWindowRect(m_hWnd, &rcWnd);
	if (rcBtn1.PtInRect(msg.ptMouse))
	{
		g_pProfileWnd->SetRequestID(m_strBtnReleteWorker[0]);
	}
	else 
	{
		g_pProfileWnd->SetRequestID(m_strBtnReleteWorker[1]);
	}
}

void CProfileWnd::_OnNotifyBtnFavoriteClick(TNotifyUI& msg)
{
    SetLayerBkImage(_T("btn_img_main_organization_menu_00.png"));

    GET_MESSENGER_DLG()->GetMainFrame()->SetCurSelCtrl(NULL);
    CButtonUI *pBtnFavorite = (CButtonUI*)msg.pSender;
    if (IsSelectFavoriteBtn(pBtnFavorite))
    {
        OnBtnFavoriteDelete(m_userData.strUserId.c_str());
        pBtnFavorite->SetBkImage(FAVORITE_NORMAL);
    }
    else
    {
        OnBtnFavoriteAdd(msg);
    }
}
void CProfileWnd::_OnNotifyBtnChatClick(TNotifyUI& msg)
{
    SetLayerBkImage(_T("btn_img_main_organization_menu_00.png"));

    std::vector<NE_MEMBER_DATA> memberVector;
    //const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(m_strID);
    GTUserStatusType eUserStatus1 = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(m_strID);
    const IGTBuddyUser* pBuddyUser = g_pMessengerActor->GetBuddyInfo(m_strID);
    GTUserStatusType eUserStatus2 = ustOFFLINE;
    if (pBuddyUser != NULL)
    {
        eUserStatus2 = pBuddyUser->GetStatus();
    }
    GTUserStatusType eUserStatus3 = ustOFFLINE;
    const IGTBuddyUser* pPeristUser = g_pMessengerActor->GetBuddyInfoFromPersist(m_strID);
    if (pPeristUser != NULL)
    {
        eUserStatus3 = pPeristUser->GetStatus();
    }

    memberVector.push_back(m_userData);
    if (eUserStatus1 != ustOFFLINE || eUserStatus2 != ustOFFLINE || eUserStatus3 != ustOFFLINE)
    {
        GET_APP()->m_pChatDialogManager->CreateMemberChat(memberVector);
    }
}
void CProfileWnd::_OnNotifyBtnMailClick(TNotifyUI& msg)
{
    SetLayerBkImage(_T("btn_img_main_organization_menu_00.png"));

    std::vector<ReceiverInfo> receiverVector;
    ReceiverInfo receiverInfo;
    //const NE_MEMBER_DATA data = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMember(m_strID);
    receiverInfo.strID = m_strID;
    receiverInfo.strName = m_userData.strName; 
    receiverVector.push_back(receiverInfo);

    GET_APP()->m_pSendNoteManager->CreateReceiverInfoListNote(receiverVector);
}

void CProfileWnd::_OnNotifyBtnSMSClick(TNotifyUI& msg)
{
    SetLayerBkImage(_T("btn_img_main_organization_menu_00.png"));

    std::vector<CSMSModel::SMSReceiverInfo> receiverVector;
    CSMSModel::SMSReceiverInfo receiverInfo;
    receiverInfo.strID = m_strID;
    receiverInfo.strName = m_userData.strName.c_str();
    receiverInfo.strCellPhone = m_userData.strCellPhone.c_str();
    receiverVector.push_back(receiverInfo);
    GET_APP()->m_pSMSDialogManager->CreateListSMS(receiverVector);
}

void CProfileWnd::_OnNotifyBtnPhoneClick(TNotifyUI& msg)
{
    SetLayerBkImage(_T("btn_img_main_organization_menu_00.png"));

    if(GET_APP()->IsAvailableIPT())
    {
        NTIPTStatusType iptMyStatus = g_pMessengerActor->GetMyIptStatus();
        NTIPTStatusType iptStatusOfBuddy = GetMemberIPTStatus(m_strID);

        CMenu menuList;
        menuList.LoadMenu(IDR_MEMU_COMMON_MENU);
        CMenu* pPopup = menuList.GetSubMenu(7);
        MakeIPTMenu(iptMyStatus, iptStatusOfBuddy, &m_userData, pPopup);

        if( pPopup != NULL )
        {
            CPoint point(msg.ptMouse.x, msg.ptMouse.y);
            ::ClientToScreen(m_hWnd, &point);
            int nCmdID = pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, point.x, point.y, CWnd::FromHandle(m_hWnd));
            OnMenuIPT(nCmdID);
        }
    }
}


void CProfileWnd::MakeIPTMenu( NTIPTStatusType iptMyStatus, NTIPTStatusType iptStatusOfBuddy, const NE_MEMBER_DATA* pMembereData, CMenu* pPopup )
{
	CString strCorpTel = m_userData.strIncoTel.c_str();
	CString strCellPhone = m_userData.strCellPhone.c_str();
	CString strExtensionTel = m_userData.strExtesion.c_str();

	//pPopup->InsertMenu(ID_MENU_CONFER_CALL, MF_BYCOMMAND, MF_SEPARATOR );
	if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->EnableMenuItem(ID_MENU_IPT_EXT_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strCorpTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_05")))
	{
		pPopup->EnableMenuItem(ID_MENU_IPT_CORP_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || strCellPhone.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_07")))
	{	
		pPopup->EnableMenuItem(ID_MENU_IPT_CELLPHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}
	if(iptMyStatus != iptstACTIVE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->EnableMenuItem(ID_MENU_IPT_CONFER, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		pPopup->EnableMenuItem(ID_MENU_IPT_TRANSFER, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	}

	if (!GET_CONFIG()->EnableFunction(_T("SR_08")))
	{
		pPopup->DeleteMenu(ID_MENU_IPT_CONFER, MF_BYCOMMAND);
		pPopup->DeleteMenu(ID_MENU_IPT_TRANSFER, MF_BYCOMMAND);
		pPopup->DeleteMenu(ID_MENU_IPT_EXT_PHONE, MF_BYCOMMAND);
	}
	if (!GET_CONFIG()->EnableFunction(_T("SR_05")))
	{
		pPopup->DeleteMenu(ID_MENU_IPT_CORP_PHONE, MF_BYCOMMAND);
	}
	if (!GET_CONFIG()->EnableFunction(_T("SR_07")))
	{
		pPopup->DeleteMenu(ID_MENU_IPT_CELLPHONE, MF_BYCOMMAND);
	}
}

void CProfileWnd::OnMenuIPT(WPARAM wParam)
{
	int nID = (int)wParam;
	CString strTelNo = _T("");

	switch (nID)
	{
	case ID_MENU_COMPANY_PHONE:
	case ID_MENU_IPT_CORP_PHONE:
		strTelNo = m_userData.strIncoTel.c_str();
		break;

	case ID_MENU_CELL_PHONE:
	case ID_MENU_IPT_CELLPHONE:
		strTelNo = m_userData.strCellPhone.c_str();
		break;

	case ID_MENU_EXT_PHONE:
	case ID_MENU_IPT_EXT_PHONE:
		strTelNo = m_userData.strExtesion.c_str();
		break;
	}

	CallToIPT(m_userData, strTelNo);
}

void CProfileWnd::CallToIPT(NE_MEMBER_DATA userData, CString strTel)
{
	if (strTel.IsEmpty())
		return;

	CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

	if (pManager)
		pManager->MakeCall(userData, strTel);
}

NTIPTStatusType CProfileWnd::GetMemberIPTStatus(LPCWSTR strUserID)
{
	NTIPTStatusType iptStatusType = iptstIDLE;
	const IGTBuddyUser* pBuddyUser = g_pMessengerActor->GetBuddyInfo(strUserID);
	if (pBuddyUser == NULL)
	{
        pBuddyUser = g_pMessengerActor->GetBuddyInfoFromPersist(strUserID);
	}
    ASSERT(pBuddyUser);
    if (pBuddyUser)
    {
        iptStatusType = pBuddyUser->GetIPTStatus();
    }

    NTIPTStatusType iptStatusTypeInModel = GET_MESSENGER_DLG()->GetWorkGroupController()->m_pModel->GetMemberIPTStatus(strUserID);
    ASSERT(iptStatusType == iptStatusTypeInModel);
	return iptStatusType;
}

bool CProfileWnd::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID)
{
	if (m_trid != trid)
		return true;

	if (eErrorCode != wasError_None)
		return false;

	if (list.nSize <= 0)
		return false;

	ShowWindow(true, true);

	GTUserStatusType eUserStatus1 = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(m_strID);
	const IGTBuddyUser* pBuddyUser = g_pMessengerActor->GetBuddyInfo(m_strID);

	GTUserStatusType eUserStatus2 = ustOFFLINE;
	if (pBuddyUser != NULL)
	{
		eUserStatus2 = pBuddyUser->GetStatus();
	}
	GTUserStatusType eUserStatus3 = ustOFFLINE;
	const IGTBuddyUser* pPeristUser = g_pMessengerActor->GetBuddyInfoFromPersist(m_strID);
	if (pPeristUser != NULL)
	{
		eUserStatus3 = pPeristUser->GetStatus();
	}
	CButtonUI* pBtnChat = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_chat")));
	if ((eUserStatus1 != ustOFFLINE || eUserStatus2 != ustOFFLINE || eUserStatus3 != ustOFFLINE) && (!GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(m_strID.GetData())))
	{
		pBtnChat->SetEnabled(true);
	}
	else
	{
		pBtnChat->SetEnabled(false);
	}

#ifdef _DEBUG

#else
	CButtonUI* pBtnSMS = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_sms")));
	if(GET_CONFIG()->EnableFunction(_T("ME_01")))
	{
		pBtnSMS->SetEnabled(true);
	}
	else
	{
		pBtnSMS->SetEnabled(false);
	}
#endif

	CButtonUI* pBtnPhone = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("btn_phone")));


	if(GET_APP()->IsAvailableIPT())
	{
		pBtnPhone->SetEnabled(true);
	}
	else
	{
		pBtnPhone->SetEnabled(false);
	}

	const NE_MEMBER_DATA &sMemberInfo = list.pList[0];
	m_userData = sMemberInfo;

	UpdateProfileImage(sMemberInfo.strUserId.c_str());
	CUCLabel* pExt = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_ext")));
	if (pExt != NULL)
	{
		pExt->SetText(sMemberInfo.strExtesion.c_str());
		pExt->SetToolTip(sMemberInfo.strExtesion.c_str());
	}
	CUCLabel* pMobile = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_mobile")));
	if (pMobile != NULL)
	{
		pMobile->SetText(sMemberInfo.strCellPhone.c_str());
		pMobile->SetToolTip(sMemberInfo.strCellPhone.c_str());
	}
	CUCLabel* pOrg = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_org")));
	if (pOrg != NULL)
	{
		pOrg->SetText(sMemberInfo.strKeyword.c_str());
		pOrg->SetToolTip(sMemberInfo.strKeyword.c_str());
	}
	CUCLabel* pCity = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_city")));
	if (pCity != NULL)
	{
		pCity->SetText(sMemberInfo.strWorkPlace.c_str());
		pCity->SetToolTip(sMemberInfo.strWorkPlace.c_str());
	}

 	CUCLabel* pMail = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_mail")));
 	if (pMail != NULL)
 	{
 		CString strShowMail = sMemberInfo.strEmail.c_str();
 		pMail->SetVisible(true);
		pMail->SetText(strShowMail);
 		pMail->SetToolTip(strShowMail);
 	}

	CUCLabel* pFax = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_fax")));
	if (pFax != NULL)
	{
		CString strFax = sMemberInfo.strFaxNum.c_str();
		pFax->SetVisible(true);
		pFax->SetText(strFax);
		pFax->SetToolTip(strFax);
	}

	CUCLabel* pRoamingPhone = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_roaming_phone")));
	if (pRoamingPhone != NULL)
	{
		CString strRoamingPhone = sMemberInfo.strRmngPhone.c_str();
		pRoamingPhone->SetVisible(true);
		pRoamingPhone->SetText(strRoamingPhone);
		pRoamingPhone->SetToolTip(strRoamingPhone);
	}

	CTextUI* pTextRelatedWorker = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("text_hide_related_worker")));
	CButtonUI* pBtnRelatedWorker = static_cast<CButtonUI*>(m_PaintManager.FindControl(kBtnRelateWorker));
	if (pTextRelatedWorker != NULL && pBtnRelatedWorker != NULL)
	{
		CString strRelatedWorker = sMemberInfo.strAddInfoCont.c_str();
		vector<CString> vecWorkersInfo;
		int nWorkerCount = SplitString(strRelatedWorker, _T(','), vecWorkersInfo);
		ASSERT(nWorkerCount != vecWorkersInfo.size());
		nWorkerCount = min(nWorkerCount, 2);
		CString strBuf = _T("");
		CString strText = _T("");
		CString strName[2] = {_T(""), _T("")};
		CString strTooltip = _T("");
		pTextRelatedWorker->SetShowHtml(true);
		pBtnRelatedWorker->SetShowHtml(true);
		SIZE szTemp = { 0 };
		szTemp.cx = 99;
		szTemp.cy = 20;
		int nBtnWidth = 1;
		for (int i=0; i<nWorkerCount; ++i)
		{
			vector<CString> vecWorkers;
			SplitString(vecWorkersInfo[i], _T('|'), vecWorkers);
			if (i == 0)
			{
				strName[0] = vecWorkers[0];
				strBuf.Format(_T("<f 4>%s</f>"), vecWorkers[0]);
				pTextRelatedWorker->SetText(strName[0]);
				m_szBtnReleteWorker[0] = pTextRelatedWorker->EstimateSize(szTemp);
				nBtnWidth += m_szBtnReleteWorker[0].cx;
				m_strBtnReleteWorker[0] = vecWorkers[1];
				strText = strBuf;
				strTooltip = strName[0];
			}
			else if (i == 1)
			{
				strName[1] = vecWorkers[0];
				strText.Format(_T("%s<f 3>%s</f><f 4>%s</f>"), strBuf, _T(", "), vecWorkers[0]);
				pTextRelatedWorker->SetText(strName[1]);
				m_szBtnReleteWorker[1] = pTextRelatedWorker->EstimateSize(szTemp);
				nBtnWidth = nBtnWidth + m_szBtnReleteWorker[1].cx + 16;
				m_strBtnReleteWorker[1] = vecWorkers[1];
				strTooltip = strName[0] + _T(", ") + strName[1];
			}
		}
		pTextRelatedWorker->SetVisible(false);
		pBtnRelatedWorker->SetText(strText);
		pBtnRelatedWorker->SetToolTip(strTooltip);
		nBtnWidth = min(nBtnWidth, 138);
		pBtnRelatedWorker->SetFixedWidth(nBtnWidth);
	}

	CUCLabel* pWorkStatus = static_cast<CUCLabel*>(m_PaintManager.FindControl(_T("edit_work_status")));
	if (pWorkStatus != NULL)
	{
		//CString strWorkStatus;
		if (GET_MESSENGER_DLG()->GetWorkGroupController()->IsMyID(sMemberInfo.strUserId.c_str()) || GET_CONFIG()->EnableFunction(_T("UI_01")))
		{	
			CString strWorkStatus = sMemberInfo.strWorkStatus.c_str();
			pWorkStatus->SetVisible(true);
			pWorkStatus->SetText(strWorkStatus);

			strWorkStatus.Replace(_T(":"),_T("\n"));
			pWorkStatus->SetToolTip(strWorkStatus);
		}
	}

// 	CTextUI* pMail = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("edit_mail")));
// 	if (pMail != NULL)
// 	{
// 		CString strShowMail = sMemberInfo.strEmail.c_str();
// 		pMail->SetVisible(true);
// 		pMail->SetText(strShowMail);
// 		pMail->SetToolTip(strShowMail);
// 		
// 	}
	CLabelUI* pDepartment = static_cast<CLabelUI*>(m_PaintManager.FindControl(_T("department")));
	if (pDepartment != NULL)
	{
		CString strShowDept = sMemberInfo.strJobPos.c_str();
		if (strShowDept.GetLength() > 1)
		{
			strShowDept += _T(",");
		}
		strShowDept += sMemberInfo.strDept.c_str();			
		pDepartment->SetVisible(true);
		pDepartment->SetText(strShowDept);
        pDepartment->SetToolTip(strShowDept);		
	}

	CTextUI* pUserName = static_cast<CTextUI*>(m_PaintManager.FindControl(_T("user_name")));
	CButtonUI* pFavorite = static_cast<CButtonUI*>(m_PaintManager.FindControl(kFavorite));
	if(pUserName != NULL && pFavorite != NULL)
	{
		pUserName->SetShowHtml(true);
		CString strHtml = _T("");
		vector<CString> vecBookmark = GET_MESSENGER_DLG()->GetMainFrame()->GetBookmarkVector();
		vector<CString>::iterator it = find(vecBookmark.begin(), vecBookmark.end(), sMemberInfo.strUserId.c_str());
		CString strShowFullName = sMemberInfo.strName.c_str();
		CString strShowName = strShowFullName;
        SIZE szTemp = { 0 };
		szTemp.cx = 99;
		szTemp.cy = 28;
		pUserName->SetVisible(false);
		int nLeft = 0;
		GetStringInRect(pUserName, strShowName, szTemp, nLeft, 80); 
		if (strShowName.GetLength() > nLeft)
		{
			strShowName = strShowName.Left(nLeft-1) + _T("...");
		}
		
		if (it != vecBookmark.end())
		{
			//strHtml.Format(_T("<c #DEE2EB>%s</c><x 2><i btn_main_bookmark_icon_sel.png>"), strShowName);
			pFavorite->SetBkImage(_T("btn_main_bookmark_icon_sel.png"));
			pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_5));
		}
		else
		{
			//strHtml.Format(_T("<c #DEE2EB>%s</c><x 2><i btn_main_bookmark_icon_nor.png>"), strShowName);
			pFavorite->SetBkImage(_T("btn_main_bookmark_icon_nor.png"));
			pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_4));
		}
		if(m_strID.CompareNoCase(g_pMessengerActor->GetUserID()) == 0)
		{
			pFavorite->SetEnabled(false);
			pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_NOT_ADD_SELF));
		}
		else
		{
			pFavorite->SetEnabled(true);
		}
		strHtml.Format(_T("<c #DEE2EB>%s</c><x 1>"), strShowName);
		pUserName->SetVisible(true);
		pUserName->SetText(strHtml);
		pUserName->SetToolTip(strShowFullName);
	}

	if (sMemberInfo.strPhotoURL.empty() != true && (m_strID == m_strMyID || GET_CONFIG()->EnableFunction(_T("UI_02")) == TRUE))
	{
		//CUserImageActor::Instance()->RequestUserImage(sMemberInfo.strUserId.c_str(),
		//	sMemberInfo.strPhotoURL.c_str());
	}

	return true;
}

CString CProfileWnd::ParseRelatedWorker(CString strRelateWorker)
{
	CString strBuf = strRelateWorker;
	vector<CString> vecWorkers;
	int nWorkerCount = SplitString(strBuf, _T(','), vecWorkers);

	return strBuf;
}

int CProfileWnd::GetStringInRect(CLabelUI *pLabelCtrl, LPCTSTR strText, SIZE szAvailable, int &nLeft, int nPixel)
{
	nLeft = 1;
	CString strTextTmp = strText;
	SIZE szUserName = { 0 };
	//szUserName.cx = 0;
	//szUserName.cy = 0;
	do 
	{
		CString strLeft = strTextTmp.Left(nLeft);
		pLabelCtrl->SetText(strLeft);
		szUserName = pLabelCtrl->EstimateSize(szAvailable);
		++nLeft;
		if (strLeft == strTextTmp)
		{
			break;
		}

	} while (szUserName.cx < nPixel);

	return nLeft;
}

LRESULT CProfileWnd::_OnMsgUserImageUpdated(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    CString* pStr = NULL;
    pStr = (CString*)wParam;
    if(pStr != NULL)
    {
        UpdateProfileImage(*pStr);
        if(pStr != NULL)
        {
            delete pStr;
            pStr = NULL;
        }
    }

    return 0;
}

LRESULT CProfileWnd::_OnMsgKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    bHandled = FALSE;
    if ((TCHAR)wParam == VK_ESCAPE)
    {
        if (g_pProfileWnd != NULL && IsWindow(g_pProfileWnd->GetHWND()))
        {
            m_bClosing = TRUE;
            g_pProfileWnd->CloseProfileWnd();
            bHandled = TRUE;
        }
    }
    return 0;
}

LRESULT CProfileWnd::_OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    bHandled = FALSE;
    if ((TCHAR)wParam == VK_F4)
    {
        m_bClosing = TRUE;
        g_pProfileWnd->CloseProfileWnd();
        bHandled = TRUE;
    }
    return 0;
}

void CProfileWnd::UpdateProfileImage(CString strUserId)
{
	if(strUserId != m_strID)
	{
		return;
	}

	CButtonUI* pProfilePic = static_cast<CButtonUI*>(m_PaintManager.FindControl(_T("profile_pic")));
	if (pProfilePic != NULL)
	{
        CString strFileName = GET_APP()->GetProfileImagePath(m_strID);
        pProfilePic->SetBkImage(strFileName);
	}
}


void CProfileWnd::OnPrepare(TNotifyUI& msg)
{
	
}

CDuiString CProfileWnd::GetSkinFile()
{
	return _T("profileWnd.xml");
}

CDuiString CProfileWnd::GetSkinFolder()
{
	return _T("skin\\nTalkRes\\");
}

LRESULT CProfileWnd::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return 0;
}

LRESULT CProfileWnd::OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return HTCLIENT;
}

LRESULT CProfileWnd::_OnMsgActivate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    bHandled = FALSE;
    if(wParam == WA_INACTIVE)
    {
        if (g_pProfileWnd != NULL)
        {
            if (m_hParentWnd != NULL)
            {
                if (m_bClosing)
                {
                    ::PostMessage(m_hParentWnd, MSG_ACTIVE_PRARENT, 0, 0);
                }
                else
                {
					if (m_bEnableClose)
					{
						::PostMessage(m_hParentWnd, MSG_INACTIVE_HIDE, 0, 0);
					}
                }
            }

            bHandled = FALSE;
        }
    }
    return 0;
}

LRESULT CProfileWnd::_OnCommandRangeUserId(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
    //int nID = (int)wParam;
    GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);
    int nGroupID = iter->second;
    std::vector<wstring> vecBuddyId;

    vecBuddyId.push_back(m_userData.strUserId.c_str()) ;
    if (!vecBuddyId.empty())
    {
        GET_MESSENGER_DLG()->GetWorkGroupController()->AddFavoriteList(vecBuddyId, nGroupID);
    }
    return 0;
}



void CProfileWnd::SetBookmark(int nOpType)
{
	CButtonUI* pFavorite = static_cast<CButtonUI*>(m_PaintManager.FindControl(kFavorite));
	if(pFavorite != NULL)
	{
		if (nOpType == BOOKMARK_ADD)
		{
			pFavorite->SetBkImage(FAVORITE_SELECT);
			pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_5));
		}
		else
		{
			pFavorite->SetBkImage(FAVORITE_NORMAL);
			pFavorite->SetToolTip(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_4));
		}
	}
}

LRESULT CProfileWnd::_OnCommandMnCreateFavoriteGroup(UINT uNotifyCode, int nID, HWND wndCtl, BOOL& bHandled)
{
	m_bEnableClose = FALSE;
	if (g_pMessengerActor->GetBuddyGroupCount() >= MAX_GROUP)
	{	
		CString strMaxGroupCnt;
		strMaxGroupCnt.Format(IDS_STRING227, MAX_GROUP);
		NMessageBox(CWnd::FromHandle(m_hWnd), strMaxGroupCnt);
		m_bEnableClose = TRUE;
		return 0;
	}

	CCreateNewGroupWnd favCreateWnd(m_hWnd);
    GET_MESSENGER_DLG()->RegisterDuiModalWnd(&favCreateWnd);
	int nRet = favCreateWnd.ShowModal();
    GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(&favCreateWnd);

	if (nRet == IDOK)
	{
		m_GroupList.clear();

		int nGroupID = favCreateWnd.GetCreatedGroupID();
		m_GroupList.insert(std::make_pair(WM_USER_ID_FAVORITE_BUTTON, nGroupID));
		std::vector<wstring> vecBuddyId;
		vecBuddyId.push_back(m_userData.strUserId.c_str()) ;
		if (!vecBuddyId.empty())
		{
			GET_MESSENGER_DLG()->GetWorkGroupController()->AddFavoriteList(vecBuddyId, nGroupID);
		}
	}
	m_bEnableClose = TRUE;
    return 0;
}

BOOL CProfileWnd::GetEnableClose()
{
	return m_bEnableClose;
}

BOOL CProfileWnd::CloseProfileWnd()
{
	if (m_bEnableClose)
	{
		Close();
		return TRUE;
	}
	return FALSE;
}

void CProfileWnd::OnUserImageActor_OnResponseUserImageInfo(CString strUserId)
{
    PostMessage(WM_USERIMAGE_UPDATED, (WPARAM)(new CString(strUserId)), 0);
}

CProfileWnd *g_pProfileWnd = NULL;